package dev.shadowsoffire.apotheosis.ench.objects;

import java.util.function.Function;
import com.mojang.datafixers.kinds.Applicative;
import com.mojang.datafixers.kinds.App;
import com.mojang.serialization.codecs.RecordCodecBuilder;
import dev.shadowsoffire.apotheosis.ench.Ench;
import net.minecraft.world.level.ItemLike;
import dev.shadowsoffire.apotheosis.Apotheosis;
import net.minecraft.world.level.storage.loot.LootContext;
import net.minecraft.world.item.ItemStack;
import it.unimi.dsi.fastutil.objects.ObjectArrayList;
import net.minecraftforge.common.loot.IGlobalLootModifier;
import net.minecraft.world.level.storage.loot.predicates.LootItemCondition;
import net.minecraft.resources.ResourceLocation;
import com.mojang.serialization.Codec;
import net.minecraftforge.common.loot.LootModifier;

public class WardenLootModifier extends LootModifier
{
    public static final Codec<WardenLootModifier> CODEC;
    public static final ResourceLocation WARDEN_TABLE_ID;
    
    public WardenLootModifier(final LootItemCondition[] conditionsIn) {
        super(conditionsIn);
    }
    
    public Codec<? extends IGlobalLootModifier> codec() {
        return (Codec<? extends IGlobalLootModifier>)WardenLootModifier.CODEC;
    }
    
    protected ObjectArrayList<ItemStack> doApply(final ObjectArrayList<ItemStack> loot, final LootContext ctx) {
        if (Apotheosis.enableEnch && WardenLootModifier.WARDEN_TABLE_ID.equals((Object)ctx.getQueriedLootTableId())) {
            int amount = 1;
            if (ctx.m_230907_().m_188501_() <= 0.1f + ctx.getLootingModifier() * 0.1f) {
                ++amount;
            }
            loot.add((Object)new ItemStack((ItemLike)Ench.Items.WARDEN_TENDRIL.get(), amount));
        }
        return loot;
    }
    
    static {
        CODEC = RecordCodecBuilder.create(inst -> codecStart(inst).apply((Applicative)inst, (Function)WardenLootModifier::new));
        WARDEN_TABLE_ID = new ResourceLocation("minecraft", "entities/warden");
    }
}
